Index: uspace/lib/bithenge/src/helenos/block.c
===================================================================
--- uspace/lib/bithenge/src/helenos/block.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/bithenge/src/helenos/block.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2012 Sean Bartell
  * All rights reserved.
@@ -103,5 +104,5 @@
 	// Initialize libblock
 	errno_t rc;
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)
 		return rc;
Index: uspace/lib/block/block.c
===================================================================
--- uspace/lib/block/block.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/block/block.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2008 Martin Decky
@@ -145,5 +146,5 @@
 }
 
-errno_t block_init(service_id_t service_id, size_t comm_size)
+errno_t block_init(service_id_t service_id)
 {
 	bd_t *bd;
@@ -260,5 +261,5 @@
 }
 
-static hash_table_ops_t cache_ops = {
+static const hash_table_ops_t cache_ops = {
 	.hash = cache_hash,
 	.key_hash = cache_key_hash,
Index: uspace/lib/block/block.h
===================================================================
--- uspace/lib/block/block.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/block/block.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2008 Jakub Jermar
  * Copyright (c) 2008 Martin Decky
@@ -99,5 +100,5 @@
 };
 
-extern errno_t block_init(service_id_t, size_t);
+extern errno_t block_init(service_id_t);
 extern void block_fini(service_id_t);
 
Index: uspace/lib/c/arch/arm32/meson.build
===================================================================
--- uspace/lib/c/arch/arm32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/arch/arm32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -30,5 +30,5 @@
 arch_src += files(
 	'src/atomic.c',
-	'src/entryjmp.S',
+	'src/entryjmp.c',
 	'src/thread_entry.S',
 	'src/syscall.c',
Index: uspace/lib/c/arch/arm32/src/atomic.c
===================================================================
--- uspace/lib/c/arch/arm32/src/atomic.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/arch/arm32/src/atomic.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -34,9 +34,14 @@
 
 #include <stdbool.h>
+#include "ras_page.h"
 
 volatile unsigned *ras_page;
 
-bool __atomic_compare_exchange_4(volatile unsigned *mem, unsigned *expected, unsigned desired, bool weak, int success, int failure)
+bool __atomic_compare_exchange_4(volatile void *mem0, void *expected0,
+    unsigned desired, bool weak, int success, int failure)
 {
+	volatile unsigned *mem = mem0;
+	unsigned *expected = expected0;
+
 	(void) success;
 	(void) failure;
@@ -81,6 +86,9 @@
 }
 
-unsigned short __atomic_fetch_add_2(volatile unsigned short *mem, unsigned short val, int model)
+unsigned short __atomic_fetch_add_2(volatile void *mem0, unsigned short val,
+    int model)
 {
+	volatile unsigned short *mem = mem0;
+
 	(void) model;
 
@@ -115,6 +123,8 @@
 }
 
-unsigned __atomic_fetch_add_4(volatile unsigned *mem, unsigned val, int model)
+unsigned __atomic_fetch_add_4(volatile void *mem0, unsigned val, int model)
 {
+	volatile unsigned *mem = mem0;
+
 	(void) model;
 
@@ -149,5 +159,5 @@
 }
 
-unsigned __atomic_fetch_sub_4(volatile unsigned *mem, unsigned val, int model)
+unsigned __atomic_fetch_sub_4(volatile void *mem, unsigned val, int model)
 {
 	return __atomic_fetch_add_4(mem, -val, model);
Index: uspace/lib/c/arch/arm32/src/crt0.S
===================================================================
--- uspace/lib/c/arch/arm32/src/crt0.S	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/arch/arm32/src/crt0.S	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -40,4 +40,5 @@
 SYMBOL(_start)
 	# Store the RAS page address into the ras_page variable
+	// FIXME: This only works for not-PIC executables.
 	ldr r0, =ras_page
 	str r2, [r0]
Index: uspace/lib/c/arch/arm32/src/entryjmp.c
===================================================================
--- uspace/lib/c/arch/arm32/src/entryjmp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/c/arch/arm32/src/entryjmp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2008 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <entry_point.h>
+#include "ras_page.h"
+
+void entry_point_jmp(void *entry_point, void *pcb)
+{
+	asm volatile (
+	    "mov r1, %0 \n"
+	    "mov r2, %1 \n"
+	    "mov r15, %2 \n"
+	    :
+	    : "r" (pcb), "r" (ras_page), "r" (entry_point)
+	    : "r1", "r2"
+	);
+
+	__builtin_unreachable();
+}
Index: uspace/lib/c/arch/arm32/src/ras_page.h
===================================================================
--- uspace/lib/c/arch/arm32/src/ras_page.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/c/arch/arm32/src/ras_page.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,1 @@
+extern volatile unsigned *ras_page;
Index: uspace/lib/c/arch/arm32/src/rtld/reloc.c
===================================================================
--- uspace/lib/c/arch/arm32/src/rtld/reloc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/arch/arm32/src/rtld/reloc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -127,14 +127,4 @@
 
 		switch (rel_type) {
-		case R_ARM_ABS32:
-			DPRINTF("ignore R_ARM_ABS32\n");
-			/*
-			 * Not sure why we get these static relocations, but
-			 * attempting to process them will crash the
-			 * loader. If we ignore them, everything
-			 * seems to work.
-			 */
-			break;
-
 		case R_ARM_TLS_DTPMOD32:
 			DPRINTF("fixup R_ARM_TLS_DTPMOD32\n");
@@ -189,5 +179,6 @@
 		case R_ARM_GLOB_DAT:
 		case R_ARM_JUMP_SLOT:
-			DPRINTF("fixup R_ARM_GLOB_DAT/JUMP_SLOT (S)\n");
+		case R_ARM_ABS32:
+			DPRINTF("fixup R_ARM_GLOB_DAT/JUMP_SLOT/ABS32 (S)\n");
 			*r_ptr = sym_addr;
 			break;
Index: uspace/lib/c/common
===================================================================
--- uspace/lib/c/common	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/c/common	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,1 @@
+../../../common
Index: uspace/lib/c/generic/assert.c
===================================================================
--- uspace/lib/c/generic/assert.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/assert.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,6 +46,6 @@
 	 * Send the message safely to kio. Nested asserts should not occur.
 	 */
-	kio_printf("Assertion failed (%s) in task %ld, file \"%s\", line %u.\n",
-	    cond, (long) task_get_id(), file, line);
+	kio_printf("Assertion failed (%s) in task %" PRIu64 ", file \"%s\", line %u.\n",
+	    cond, task_get_id(), file, line);
 
 	stacktrace_kio_print();
@@ -60,6 +60,6 @@
 	 * Send the message safely to kio. Nested asserts should not occur.
 	 */
-	kio_printf("Assertion failed (%s) in task %ld, file \"%s\", line %u.\n",
-	    cond, (long) task_get_id(), file, line);
+	kio_printf("Assertion failed (%s) in task %" PRIu64 ", file \"%s\", line %u.\n",
+	    cond, task_get_id(), file, line);
 
 	stacktrace_kio_print();
@@ -77,6 +77,6 @@
 	 * assertions.
 	 */
-	kio_printf("Assertion failed (%s) in task %ld, file \"%s\", line %u.\n",
-	    cond, (long) task_get_id(), file, line);
+	kio_printf("Assertion failed (%s) in task %" PRIu64 ", file \"%s\", line %u.\n",
+	    cond, task_get_id(), file, line);
 	stacktrace_print();
 
Index: uspace/lib/c/generic/async/ports.c
===================================================================
--- uspace/lib/c/generic/async/ports.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/async/ports.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -123,5 +123,5 @@
 
 /** Operations for the port hash table. */
-static hash_table_ops_t interface_hash_table_ops = {
+static const hash_table_ops_t interface_hash_table_ops = {
 	.hash = interface_hash,
 	.key_hash = interface_key_hash,
@@ -151,5 +151,5 @@
 
 /** Operations for the port hash table. */
-static hash_table_ops_t port_hash_table_ops = {
+static const hash_table_ops_t port_hash_table_ops = {
 	.hash = port_hash,
 	.key_hash = port_key_hash,
Index: uspace/lib/c/generic/async/server.c
===================================================================
--- uspace/lib/c/generic/async/server.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/async/server.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -250,5 +250,5 @@
 
 /** Operations for the client hash table. */
-static hash_table_ops_t client_hash_table_ops = {
+static const hash_table_ops_t client_hash_table_ops = {
 	.hash = client_hash,
 	.key_hash = client_key_hash,
@@ -511,5 +511,5 @@
 
 /** Operations for the notification hash table. */
-static hash_table_ops_t notification_hash_table_ops = {
+static const hash_table_ops_t notification_hash_table_ops = {
 	.hash = notification_hash,
 	.key_hash = notification_key_hash,
Index: uspace/lib/c/generic/dbgcon.c
===================================================================
--- uspace/lib/c/generic/dbgcon.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/c/generic/dbgcon.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <dbgcon.h>
+#include <libc.h>
+#include <stdbool.h>
+
+bool dbgcon_enable(void)
+{
+	return __SYSCALL0(SYS_DEBUG_CONSOLE);
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/device/hw_res.c
===================================================================
--- uspace/lib/c/generic/device/hw_res.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/device/hw_res.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2010 Lenka Trochtova
  * All rights reserved.
@@ -161,4 +162,28 @@
 }
 
+/** Get bus flags.
+ *
+ * @param sess HW res session
+ * @param rflags Place to store the flags
+ *
+ * @return Error code.
+ *
+ */
+errno_t hw_res_get_flags(async_sess_t *sess, hw_res_flags_t *rflags)
+{
+	async_exch_t *exch = async_exchange_begin(sess);
+
+	sysarg_t flags;
+	const errno_t ret = async_req_1_1(exch, DEV_IFACE_ID(HW_RES_DEV_IFACE),
+	    HW_RES_GET_FLAGS, &flags);
+
+	async_exchange_end(exch);
+
+	if (ret == EOK)
+		*rflags = flags;
+
+	return ret;
+}
+
 /** @}
  */
Index: uspace/lib/c/generic/io/asprintf.c
===================================================================
--- uspace/lib/c/generic/io/asprintf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/asprintf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,5 +39,5 @@
 #include <stddef.h>
 #include <str.h>
-#include <io/printf_core.h>
+#include <printf_core.h>
 
 static int asprintf_str_write(const char *str, size_t count, void *unused)
Index: uspace/lib/c/generic/io/kio.c
===================================================================
--- uspace/lib/c/generic/io/kio.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/kio.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,5 +42,5 @@
 #include <abi/kio.h>
 #include <io/kio.h>
-#include <io/printf_core.h>
+#include <printf_core.h>
 #include <macros.h>
 #include <libarch/config.h>
Index: uspace/lib/c/generic/io/printf.c
===================================================================
--- uspace/lib/c/generic/io/printf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/printf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -33,5 +33,5 @@
  */
 
-#include <io/printf_core.h>
+#include <printf_core.h>
 #include <stdio.h>
 
Index: uspace/lib/c/generic/io/vprintf.c
===================================================================
--- uspace/lib/c/generic/io/vprintf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/vprintf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -35,5 +35,5 @@
 #include <stdarg.h>
 #include <stdio.h>
-#include <io/printf_core.h>
+#include <printf_core.h>
 #include <fibril_synch.h>
 #include <async.h>
Index: uspace/lib/c/generic/io/vsnprintf.c
===================================================================
--- uspace/lib/c/generic/io/vsnprintf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/io/vsnprintf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
 #include <stdio.h>
 #include <str.h>
-#include <io/printf_core.h>
+#include <printf_core.h>
 #include <errno.h>
 
Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/loc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2007 Josef Cejka
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,8 +39,5 @@
 #include <stdbool.h>
 
-static FIBRIL_MUTEX_INITIALIZE(loc_supp_block_mutex);
 static FIBRIL_MUTEX_INITIALIZE(loc_cons_block_mutex);
-
-static FIBRIL_MUTEX_INITIALIZE(loc_supplier_mutex);
 static FIBRIL_MUTEX_INITIALIZE(loc_consumer_mutex);
 
@@ -50,8 +47,5 @@
 static void *cat_change_arg = NULL;
 
-static async_sess_t *loc_supp_block_sess = NULL;
 static async_sess_t *loc_cons_block_sess = NULL;
-
-static async_sess_t *loc_supplier_sess = NULL;
 static async_sess_t *loc_consumer_sess = NULL;
 
@@ -108,5 +102,5 @@
 	if (!loc_callback_created) {
 		async_exch_t *exch =
-		    loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		    loc_exchange_begin_blocking();
 
 		ipc_call_t answer;
@@ -135,96 +129,49 @@
 /** Start an async exchange on the loc session (blocking).
  *
- * @param iface Location service interface to choose
- *
  * @return New exchange.
  *
  */
-async_exch_t *loc_exchange_begin_blocking(iface_t iface)
-{
-	switch (iface) {
-	case INTERFACE_LOC_SUPPLIER:
-		fibril_mutex_lock(&loc_supp_block_mutex);
-
-		while (loc_supp_block_sess == NULL) {
-			clone_session(&loc_supplier_mutex, loc_supplier_sess,
-			    &loc_supp_block_sess);
-
-			if (loc_supp_block_sess == NULL)
-				loc_supp_block_sess =
-				    service_connect_blocking(SERVICE_LOC,
-				    INTERFACE_LOC_SUPPLIER, 0, NULL);
-		}
-
-		fibril_mutex_unlock(&loc_supp_block_mutex);
-
-		clone_session(&loc_supplier_mutex, loc_supp_block_sess,
-		    &loc_supplier_sess);
-
-		return async_exchange_begin(loc_supp_block_sess);
-	case INTERFACE_LOC_CONSUMER:
-		fibril_mutex_lock(&loc_cons_block_mutex);
-
-		while (loc_cons_block_sess == NULL) {
-			clone_session(&loc_consumer_mutex, loc_consumer_sess,
-			    &loc_cons_block_sess);
-
-			if (loc_cons_block_sess == NULL)
-				loc_cons_block_sess =
-				    service_connect_blocking(SERVICE_LOC,
-				    INTERFACE_LOC_CONSUMER, 0, NULL);
-		}
-
-		fibril_mutex_unlock(&loc_cons_block_mutex);
-
-		clone_session(&loc_consumer_mutex, loc_cons_block_sess,
-		    &loc_consumer_sess);
-
-		return async_exchange_begin(loc_cons_block_sess);
-	default:
+async_exch_t *loc_exchange_begin_blocking(void)
+{
+	fibril_mutex_lock(&loc_cons_block_mutex);
+
+	while (loc_cons_block_sess == NULL) {
+		clone_session(&loc_consumer_mutex, loc_consumer_sess,
+		    &loc_cons_block_sess);
+
+		if (loc_cons_block_sess == NULL)
+			loc_cons_block_sess =
+			    service_connect_blocking(SERVICE_LOC,
+			    INTERFACE_LOC_CONSUMER, 0, NULL);
+	}
+
+	fibril_mutex_unlock(&loc_cons_block_mutex);
+
+	clone_session(&loc_consumer_mutex, loc_cons_block_sess,
+	    &loc_consumer_sess);
+
+	return async_exchange_begin(loc_cons_block_sess);
+}
+
+/** Start an async exchange on the loc session.
+ *
+ * @return New exchange.
+ *
+ */
+async_exch_t *loc_exchange_begin(void)
+{
+	fibril_mutex_lock(&loc_consumer_mutex);
+
+	if (loc_consumer_sess == NULL)
+		loc_consumer_sess =
+		    service_connect(SERVICE_LOC,
+		    INTERFACE_LOC_CONSUMER, 0, NULL);
+
+	fibril_mutex_unlock(&loc_consumer_mutex);
+
+	if (loc_consumer_sess == NULL)
 		return NULL;
-	}
-}
-
-/** Start an async exchange on the loc session.
- *
- * @param iface Location service interface to choose
- *
- * @return New exchange.
- *
- */
-async_exch_t *loc_exchange_begin(iface_t iface)
-{
-	switch (iface) {
-	case INTERFACE_LOC_SUPPLIER:
-		fibril_mutex_lock(&loc_supplier_mutex);
-
-		if (loc_supplier_sess == NULL)
-			loc_supplier_sess =
-			    service_connect(SERVICE_LOC,
-			    INTERFACE_LOC_SUPPLIER, 0, NULL);
-
-		fibril_mutex_unlock(&loc_supplier_mutex);
-
-		if (loc_supplier_sess == NULL)
-			return NULL;
-
-		return async_exchange_begin(loc_supplier_sess);
-	case INTERFACE_LOC_CONSUMER:
-		fibril_mutex_lock(&loc_consumer_mutex);
-
-		if (loc_consumer_sess == NULL)
-			loc_consumer_sess =
-			    service_connect(SERVICE_LOC,
-			    INTERFACE_LOC_CONSUMER, 0, NULL);
-
-		fibril_mutex_unlock(&loc_consumer_mutex);
-
-		if (loc_consumer_sess == NULL)
-			return NULL;
-
-		return async_exchange_begin(loc_consumer_sess);
-	default:
-		return NULL;
-	}
+
+	return async_exchange_begin(loc_consumer_sess);
 }
 
@@ -239,8 +186,27 @@
 }
 
-/** Register new server with loc. */
-errno_t loc_server_register(const char *name)
-{
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
+/** Register new server with loc.
+ *
+ * @param name Server name
+ * @param rsrv Place to store new server object on success
+ * @return EOK on succes or an error code
+ */
+errno_t loc_server_register(const char *name, loc_srv_t **rsrv)
+{
+	async_exch_t *exch;
+	loc_srv_t *srv;
+
+	srv = calloc(1, sizeof(loc_srv_t));
+	if (srv == NULL)
+		return ENOMEM;
+
+	srv->sess = service_connect_blocking(SERVICE_LOC,
+	    INTERFACE_LOC_SUPPLIER, 0, NULL);
+	if (srv->sess == NULL) {
+		free(srv);
+		return ENOMEM;
+	}
+
+	exch = async_exchange_begin(srv->sess);
 
 	ipc_call_t answer;
@@ -250,5 +216,7 @@
 	if (retval != EOK) {
 		async_forget(req);
-		loc_exchange_end(exch);
+		async_exchange_end(exch);
+		async_hangup(srv->sess);
+		free(srv);
 		return retval;
 	}
@@ -262,19 +230,39 @@
 	 */
 	async_wait_for(req, &retval);
-	loc_exchange_end(exch);
-
+	async_exchange_end(exch);
+
+	if (retval != EOK) {
+		async_hangup(srv->sess);
+		free(srv);
+		return retval;
+	}
+
+	*rsrv = srv;
 	return retval;
 }
 
+/** Unregister server from loc.
+ *
+ * Unregister server and free server object.
+ *
+ * @param srv Server object
+ */
+void loc_server_unregister(loc_srv_t *srv)
+{
+	async_hangup(srv->sess);
+	free(srv);
+}
+
 /** Register new service.
  *
- * @param      fqsn  Fully qualified service name
- * @param[out] sid   Service ID of new service
- *
- */
-errno_t loc_service_register(const char *fqsn, service_id_t *sid)
-{
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
-
+ * @param srv Server object
+ * @param fqsn Fully qualified service name
+ * @param sid  Service ID of new service
+ *
+ */
+errno_t loc_service_register(loc_srv_t *srv, const char *fqsn,
+    service_id_t *sid)
+{
+	async_exch_t *exch = async_exchange_begin(srv->sess);
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, LOC_SERVICE_REGISTER, &answer);
@@ -283,5 +271,5 @@
 	if (retval != EOK) {
 		async_forget(req);
-		loc_exchange_end(exch);
+		async_exchange_end(exch);
 		return retval;
 	}
@@ -293,5 +281,5 @@
 	 */
 	async_wait_for(req, &retval);
-	loc_exchange_end(exch);
+	async_exchange_end(exch);
 
 	if (retval != EOK) {
@@ -310,14 +298,15 @@
 /** Unregister service.
  *
- * @param sid	Service ID
- */
-errno_t loc_service_unregister(service_id_t sid)
+ * @param srv Server object
+ * @param sid Service ID
+ */
+errno_t loc_service_unregister(loc_srv_t *srv, service_id_t sid)
 {
 	async_exch_t *exch;
 	errno_t retval;
 
-	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
+	exch = async_exchange_begin(srv->sess);
 	retval = async_req_1_0(exch, LOC_SERVICE_UNREGISTER, sid);
-	loc_exchange_end(exch);
+	async_exchange_end(exch);
 
 	return (errno_t)retval;
@@ -330,7 +319,7 @@
 
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin_blocking();
 	else {
-		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin();
 		if (exch == NULL)
 			return errno;
@@ -383,5 +372,5 @@
 
 	*name = NULL;
-	exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	exch = loc_exchange_begin_blocking();
 
 	ipc_call_t answer;
@@ -463,7 +452,7 @@
 
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin_blocking();
 	else {
-		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin();
 		if (exch == NULL)
 			return errno;
@@ -512,7 +501,7 @@
 
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin_blocking();
 	else {
-		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin();
 		if (exch == NULL)
 			return errno;
@@ -548,5 +537,5 @@
 loc_object_type_t loc_id_probe(service_id_t handle)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 
 	sysarg_t type;
@@ -579,5 +568,5 @@
 int loc_null_create(void)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 
 	sysarg_t null_id;
@@ -594,5 +583,5 @@
 void loc_null_destroy(int null_id)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 	async_req_1_0(exch, LOC_NULL_DESTROY, (sysarg_t) null_id);
 	loc_exchange_end(exch);
@@ -611,16 +600,19 @@
 /** Add service to category.
  *
- * @param svc_id	Service ID
- * @param cat_id	Category ID
- * @return		EOK on success or an error code
- */
-errno_t loc_service_add_to_cat(service_id_t svc_id, service_id_t cat_id)
+ * @param srv    Server object
+ * @param svc_id Service ID
+ * @param cat_id Category ID
+ *
+ * @return EOK on success or an error code
+ */
+errno_t loc_service_add_to_cat(loc_srv_t *srv, service_id_t svc_id,
+    service_id_t cat_id)
 {
 	async_exch_t *exch;
 	errno_t retval;
 
-	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
+	exch = async_exchange_begin(srv->sess);
 	retval = async_req_2_0(exch, LOC_SERVICE_ADD_TO_CAT, svc_id, cat_id);
-	loc_exchange_end(exch);
+	async_exchange_end(exch);
 
 	return retval;
@@ -641,5 +633,5 @@
 size_t loc_count_namespaces(void)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 	size_t size = loc_count_namespaces_internal(exch);
 	loc_exchange_end(exch);
@@ -650,5 +642,5 @@
 size_t loc_count_services(service_id_t ns_handle)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 	size_t size = loc_count_services_internal(exch, ns_handle);
 	loc_exchange_end(exch);
@@ -661,5 +653,5 @@
 	/* Loop until read is succesful */
 	while (true) {
-		async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		async_exch_t *exch = loc_exchange_begin_blocking();
 		size_t count = loc_count_namespaces_internal(exch);
 		loc_exchange_end(exch);
@@ -672,5 +664,5 @@
 			return 0;
 
-		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin();
 
 		ipc_call_t answer;
@@ -710,5 +702,5 @@
 	/* Loop until read is succesful */
 	while (true) {
-		async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+		async_exch_t *exch = loc_exchange_begin_blocking();
 		size_t count = loc_count_services_internal(exch, ns_handle);
 		loc_exchange_end(exch);
@@ -721,5 +713,5 @@
 			return 0;
 
-		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
+		exch = loc_exchange_begin();
 
 		ipc_call_t answer;
@@ -758,5 +750,5 @@
     sysarg_t *id_buf, size_t buf_size, size_t *act_size)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking();
 
 	ipc_call_t answer;
Index: uspace/lib/c/generic/malloc.c
===================================================================
--- uspace/lib/c/generic/malloc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/malloc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdalign.h>
 #include <stdbool.h>
@@ -47,4 +47,5 @@
 #include <stdlib.h>
 #include <adt/gcdlcm.h>
+#include <malloc.h>
 
 #include "private/malloc.h"
@@ -773,24 +774,4 @@
 }
 
-/** Allocate memory by number of elements
- *
- * @param nmemb Number of members to allocate.
- * @param size  Size of one member in bytes.
- *
- * @return Allocated memory or NULL.
- *
- */
-void *calloc(const size_t nmemb, const size_t size)
-{
-	// FIXME: Check for overflow
-
-	void *block = malloc(nmemb * size);
-	if (block == NULL)
-		return NULL;
-
-	memset(block, 0, nmemb * size);
-	return block;
-}
-
 /** Allocate memory
  *
Index: uspace/lib/c/generic/rndgen.c
===================================================================
--- uspace/lib/c/generic/rndgen.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/rndgen.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -92,4 +92,30 @@
 }
 
+/** Generate random 16-bit integer.
+ *
+ * @param rndgen Random number generator
+ * @param rw Place to store random 16-bit integer
+ * @return EOK on success or error code
+ */
+errno_t rndgen_uint16(rndgen_t *rndgen, uint16_t *rw)
+{
+	int i;
+	uint8_t b;
+	uint16_t w;
+	errno_t rc;
+
+	w = 0;
+	for (i = 0; i < 2; i++) {
+		rc = rndgen_uint8(rndgen, &b);
+		if (rc != EOK)
+			return rc;
+
+		w = (w << 8) | b;
+	}
+
+	*rw = w;
+	return EOK;
+}
+
 /** Generate random 32-bit integer.
  *
Index: uspace/lib/c/generic/rtld/module.c
===================================================================
--- uspace/lib/c/generic/rtld/module.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/rtld/module.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2008 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -343,9 +343,21 @@
 {
 	list_foreach(rtld->modules, modules_link, module_t, m) {
-		/* Skip rtld module, since it has already been processed */
-		if (m != &rtld->rtld) {
+		/*
+		 * Skip rtld module, since it has already been processed.
+		 * Skip start / main program -- leave it for later
+		 */
+		if (m != &rtld->rtld && m != start) {
 			module_process_relocs(m);
 		}
 	}
+
+	/*
+	 * Now that shared libraries have been processed and their variables
+	 * are thus initialized, we can process the main program,
+	 * which may contain COPY relocations that copy value from shared
+	 * library variables to instances of those variables defined
+	 * in the main program.
+	 */
+	module_process_relocs(start);
 }
 
Index: uspace/lib/c/generic/rtld/rtld.c
===================================================================
--- uspace/lib/c/generic/rtld/rtld.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/c/generic/rtld/rtld.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -187,5 +187,7 @@
 		assert(((uintptr_t) dtv[m->id]) % m->tls_align == 0);
 
-		memcpy(dtv[m->id], m->tdata, m->tdata_size);
+		if (m->tdata)
+			memcpy(dtv[m->id], m->tdata, m->tdata_size);
+
 		memset(dtv[m->id] + m->tdata_size, 0, m->tbss_size);
 	}
